<a id="mypy-boto3-backup-gateway"></a>

# mypy-boto3-backup-gateway

[![PyPI - mypy-boto3-backup-gateway](https://img.shields.io/pypi/v/mypy-boto3-backup-gateway.svg?color=blue)](https://pypi.org/project/mypy-boto3-backup-gateway)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-backup-gateway.svg?color=blue)](https://pypi.org/project/mypy-boto3-backup-gateway)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/mypy-boto3-backup-gateway?color=blue)](https://pypistats.org/packages/mypy-boto3-backup-gateway)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[boto3.BackupGateway 1.20.49](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/backup-gateway.html#BackupGateway)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 6.4.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[mypy-boto3-backup-gateway docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_backup_gateway/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/main/demo.gif)

- [mypy-boto3-backup-gateway](#mypy-boto3-backup-gateway)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)
  - [Versioning](#versioning)
  - [Documentation](#documentation)
  - [Support and contributing](#support-and-contributing)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `BackupGateway`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `boto3-stubs` for `BackupGateway` service.

```bash
# install with boto3 type annotations
python -m pip install 'boto3-stubs[backup-gateway]'

# Lite version does not provide session.client/resource overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'boto3-stubs-lite[backup-gateway]'

# standalone installation
python -m pip install mypy-boto3-backup-gateway
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto3-stubs[backup-gateway]` in your environment:
  `python -m pip install 'boto3-stubs[backup-gateway]'`

Both type checking and auto-complete should work for `BackupGateway` service.
No explicit type annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

- Install `boto3-stubs[backup-gateway]` in your environment:
  `python -m pip install 'boto3-stubs[backup-gateway]'`

Both type checking and auto-complete should work for `BackupGateway` service.
No explicit type annotations required, write your `boto3` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed
`boto3-stubs` submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto3-stubs[backup-gateway]` in your environment:
  `python -m pip install 'boto3-stubs[backup-gateway]'`
- Run `mypy` as usual

Type checking should work for `BackupGateway` service. No explicit type
annotations required, write your `boto3` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto3-stubs[backup-gateway]` in your environment:
  `python -m pip install 'boto3-stubs[backup-gateway]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `BackupGateway` service. No explicit type
annotations required, write your `boto3` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`BackupGatewayClient` provides annotations for
`boto3.client("backup-gateway")`.

```python
from boto3.session import Session

from mypy_boto3_backup_gateway import BackupGatewayClient

client: BackupGatewayClient = Session().client("backup-gateway")

# now client usage is checked by mypy and IDE should provide code auto-complete
```

<a id="paginators-annotations"></a>

### Paginators annotations

`mypy_boto3_backup_gateway.paginator` module contains type annotations for all
paginators.

```python
from boto3.session import Session

from mypy_boto3_backup_gateway import BackupGatewayClient
from mypy_boto3_backup_gateway.paginator import (
    ListGatewaysPaginator,
    ListHypervisorsPaginator,
    ListVirtualMachinesPaginator,
)

client: BackupGatewayClient = Session().client("backup-gateway")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
list_gateways_paginator: ListGatewaysPaginator = client.get_paginator("list_gateways")
list_hypervisors_paginator: ListHypervisorsPaginator = client.get_paginator("list_hypervisors")
list_virtual_machines_paginator: ListVirtualMachinesPaginator = client.get_paginator("list_virtual_machines")
```

<a id="literals"></a>

### Literals

`mypy_boto3_backup_gateway.literals` module contains literals extracted from
shapes that can be used in user code for type checking.

```python
from mypy_boto3_backup_gateway.literals import (
    GatewayTypeType,
    HypervisorStateType,
    ListGatewaysPaginatorName,
    ListHypervisorsPaginatorName,
    ListVirtualMachinesPaginatorName,
    ServiceName,
    PaginatorName,
)

def check_value(value: GatewayTypeType) -> bool:
    ...
```

<a id="typed-dictionaries"></a>

### Typed dictionaries

`mypy_boto3_backup_gateway.type_defs` module contains structures and shapes
assembled to typed dictionaries for additional type checking.

```python
from mypy_boto3_backup_gateway.type_defs import (
    AssociateGatewayToServerInputRequestTypeDef,
    AssociateGatewayToServerOutputTypeDef,
    CreateGatewayInputRequestTypeDef,
    CreateGatewayOutputTypeDef,
    DeleteGatewayInputRequestTypeDef,
    DeleteGatewayOutputTypeDef,
    DeleteHypervisorInputRequestTypeDef,
    DeleteHypervisorOutputTypeDef,
    DisassociateGatewayFromServerInputRequestTypeDef,
    DisassociateGatewayFromServerOutputTypeDef,
    GatewayTypeDef,
    HypervisorTypeDef,
    ImportHypervisorConfigurationInputRequestTypeDef,
    ImportHypervisorConfigurationOutputTypeDef,
    ListGatewaysInputRequestTypeDef,
    ListGatewaysOutputTypeDef,
    ListHypervisorsInputRequestTypeDef,
    ListHypervisorsOutputTypeDef,
    ListTagsForResourceInputRequestTypeDef,
    ListTagsForResourceOutputTypeDef,
    ListVirtualMachinesInputRequestTypeDef,
    ListVirtualMachinesOutputTypeDef,
    PaginatorConfigTypeDef,
    PutMaintenanceStartTimeInputRequestTypeDef,
    PutMaintenanceStartTimeOutputTypeDef,
    ResponseMetadataTypeDef,
    TagResourceInputRequestTypeDef,
    TagResourceOutputTypeDef,
    TagTypeDef,
    TestHypervisorConfigurationInputRequestTypeDef,
    UntagResourceInputRequestTypeDef,
    UntagResourceOutputTypeDef,
    UpdateGatewayInformationInputRequestTypeDef,
    UpdateGatewayInformationOutputTypeDef,
    UpdateHypervisorInputRequestTypeDef,
    UpdateHypervisorOutputTypeDef,
    VirtualMachineTypeDef,
)

def get_structure() -> AssociateGatewayToServerInputRequestTypeDef:
    return {
      ...
    }
```

<a id="versioning"></a>

## Versioning

`mypy-boto3-backup-gateway` version is the same as related `boto3` version and
follows [PEP 440](https://www.python.org/dev/peps/pep-0440/) format.

<a id="documentation"></a>

## Documentation

All type annotations can be found in
[mypy-boto3-backup-gateway docs](https://vemel.github.io/boto3_stubs_docs/mypy_boto3_backup_gateway/)

<a id="support-and-contributing"></a>

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
